/**
 * Database Migration API
 * Use the Oracle Cloud Infrastructure Database Migration APIs to perform database migration operations.
 * OpenAPI spec version: 20200720
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details that will override an existing Migration configuration that will be cloned.
 *
 */
export interface CloneMigrationDetails {
    /**
     * Migration Display Name
     *
     */
    "displayName"?: string;
    /**
     * OCID of the compartment
     *
     */
    "compartmentId"?: string;
    /**
     * The OCID of the registered on-premises ODMS Agent. Only valid for Offline Logical Migrations.
     *
     */
    "agentId"?: string;
    /**
     * The OCID of the Source Database Connection.
     *
     */
    "sourceDatabaseConnectionId": string;
    /**
     * The OCID of the Source Container Database Connection. Only used for Online migrations.
     * Only Connections of type Non-Autonomous can be used as source container databases.
     *
     */
    "sourceContainerDatabaseConnectionId"?: string;
    /**
     * The OCID of the Target Database Connection.
     *
     */
    "targetDatabaseConnectionId": string;
    /**
     * Database objects to exclude from migration.
     *
     */
    "excludeObjects"?: Array<model.DatabaseObject>;
    "vaultDetails"?: model.CreateVaultDetails;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace CloneMigrationDetails {
    function getJsonObj(obj: CloneMigrationDetails): object;
}
