/**
 * Marketplace Service API
 * Manage applications in Oracle Cloud Infrastructure Marketplace.
 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The model for a summary of an Oracle Cloud Infrastructure publication
 */
export interface PublicationSummary {
    /**
     * the lifecycleState of the listing
     */
    "lifecycleState": string;
    /**
     * The Compartment id where the listings exists
     */
    "compartmentId": string;
    /**
     * The unique identifier for the listing in Marketplace.
     */
    "id": string;
    /**
     * The name of the listing.
     */
    "name": string;
    /**
     * A short description of the listing.
     */
    "shortDescription"?: string;
    "icon"?: model.UploadData;
    /**
     * The listing's package type.
     */
    "packageType"?: model.PackageTypeEnum;
    /**
     * List of operating systems supprted.
     */
    "supportedOperatingSystems"?: Array<model.OperatingSystem>;
    /**
     * In which catalog the listing should exist.
     */
    "listingType": model.ListingType;
    /**
      * The date and time this publication was created, expressed in [RFC 3339](https://tools.ietf.org/html/rfc3339)
  * timestamp format.
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeCreated"?: Date;
}
export declare namespace PublicationSummary {
    function getJsonObj(obj: PublicationSummary): object;
}
