/**
 * Scanning API
 * Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
 * OpenAPI spec version: 20210215
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details on a CVE
 */
export interface CveDetails {
    /**
     * CVE ID
     */
    "cveReference": string;
    /**
     * Vulnerability title
     */
    "title": string;
    /**
     * CVE description
     */
    "description"?: string;
    /**
     * ID of related CVE, if applicable
     */
    "relatedCveReference"?: string;
    /**
     * CVSS 3 Score
     */
    "cvss3": string;
    /**
     * Date/time the CVE was published
     */
    "timePublished": Date;
    /**
     * Date/time the CVE was last modified
     */
    "timeUpdated": Date;
}
export declare namespace CveDetails {
    function getJsonObj(obj: CveDetails): object;
}
