/**
 * Scanning API
 * Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
 * OpenAPI spec version: 20210215
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Information on a host impacted by a vulnerability
 */
export interface HostVulnerabilityImpactedHostSummary {
    /**
     * The compute instance ID of the impacted host
     */
    "instanceId": string;
    /**
     * The compartment ID of the impacted host
     */
    "compartmentId": string;
    /**
     * The ID of the last host agent scan result
     */
    "lastAgentScanId": string;
    /**
     * The current state of the resource.
     */
    "lifecycleState"?: model.LifecycleState;
}
export declare namespace HostVulnerabilityImpactedHostSummary {
    function getJsonObj(obj: HostVulnerabilityImpactedHostSummary): object;
}
